	SUBROUTINE CURRENT_IMAGE(DSP)
!
!  gets specifications from user for current image; may be modified
!  for input in any convenient mode; if image is to be displayed,
!  window limits, image position, and expansion factors must be 
!  specified; otherwise, defaults are supplied
!
!			name	type	description
!
!  input argument:	DSP	LOG*1	.TRUE. if a display window is
!					  to be set up
!  input from user
!   for file ident:	IMFILE	CHAR*128 fully qualified image file name;
!					  up to 128 characters in length
!   for image display:	IXMIN	INT*2	left window edge on display device
!			IXMAX	INT*2	right window edge
!			IYMIN	INT*2	top window edge
!			IYMAX	INT*2	bottom window edge
!			CENTRMLC INT*2	mirror location count of image
!					  scan line to go in center of window
!			PIXOFF	INT*2	numbers of pixels to be skipped 
!					  in the scan line record before the
!					  top of the display
!			FCTDWN	REAL*4	image expansion factor
!
!
	COMMON /IMAGE/	IMFILE,FCTDWN,FCTACR,NPHOT,CENTRMLC,PIXOFF
	COMMON /IWINDOW/IXMIN,IXMAX,IYMIN,IYMAX
	COMMON /MAFREC/	HEADER,SCAN
!
	CHARACTER*128	IMFILE
	BYTE		HEADER(404),SCAN(174)
	INTEGER*2	NPHOT,IXMIN,IXMAX,IYMIN,IYMAX,LCENTR(3),
     &			CENTRMLC,PIXOFF,SAVE
	INTEGER*4	PHOTID, i
	REAL*4		FCTDWN,FCTACR
	LOGICAL*1	DSP
!
	EQUIVALENCE (HEADER(25),PHOTID)

        External OpenMAF,CloseMAF,ReadMAF   !$pragma C(OpenMAF,CloseMAF,ReadMAF)

	DATA LCENTR/80,73,90/

!---identify image file
	WRITE(6,'(A, $)') 'Enter complete image file name >'
	READ(5,'(A)',end=666) IMFILE

!---open file, read header record, get photometer ID (1, 2, or 3)
        i = Index (IMFile, ' ')
        IMFile ( i:i ) = Char (0)
        Call OpenMAF (IMFile)
        Call ReadMAF (Header, 404)
        Call MAF_Header ()

        NPHOT = PhotID
        Call CloseMAF ()

!---if image is to be displayed
!---set screen window limits
	IF (DSP) THEN
	    WRITE(6,'(A, $)')
     &		'Enter left and right display window edges [I,I] >'
	    READ(5,*) IXMIN,IXMAX
	    IF (IXMIN.GT.IXMAX) THEN
		SAVE = IXMIN
		IXMIN = IXMAX
		IXMAX = SAVE
	    ENDIF
	    WRITE(6,'(A, $)')
     &		'Enter top and bottom display window edges [I,I] >'
	    READ(5,*) IYMIN,IYMAX
	    IF (IYMIN.GT.IYMAX) THEN
		SAVE = IYMIN
		IYMIN = IYMAX
		IYMAX = SAVE
	    ENDIF

!---identify portion of image to be displayed in screen window
	    WRITE(6,'(A, $)') 'Enter center MLC or 0 for default [I] >'
	    READ(5,*) CENTRMLC
	    IF (CENTRMLC.EQ.0) CENTRMLC = LCENTR(NPHOT)
	    WRITE(6,'(A, $)') 'Enter pixel offset to top of display [I] >'
	    READ(5,*) PIXOFF
	    WRITE(6,'(A, $)') 'Enter expansion factor [R] >'
	    READ(5,*) FCTDWN
	    FCTACR = FCTDWN

!---if no display, supply defaults
	ELSE
	    IXMIN = 1
	    IXMAX = 128
	    IYMIN = 1
	    IYMAX = 150
	    FCTDWN = 1.
	    FCTACR = 1.
	    CENTRMLC = LCENTR(NPHOT)
	    PIXOFF = 0
	ENDIF

666     type*,' '
	RETURN
	END
