	PROGRAM MAFCRD
!
!  writes in the default directory a geographic coordinate file (.GEO)
!  and a corrected geomagnetic coordinate file (.CGM)
!  for each input DESAI image file
!
!  VMS FORTRAN version 6 by Rae Dvorsky, University of Iowa, November 1991;
!		updated, July 1992
!
!  SunOS (Unix) FORTRAN (v1.4) version ported by Rick Dyson 29-Sep-1992
!
!
	INCLUDE 'MAFrec.inc'
!
	COMMON /IMAGE/	FileName,FCTDWN,FCTACR,NPHOT,CENTRMLC,PIXOFF
	COMMON /COORDS/ KHEAD,KSCAN
!
	CHARACTER*128	FileName,NFILE
	INTEGER*2	K,I1,I2,IND,L,N,i
	BYTE		KHEAD(200),KSCAN(628)
	INTEGER*2	NPHOT,CENTRMLC,PIXOFF
	REAL*4		FCTDWN,FCTACR

        External OpenMAF,CloseMAF,ReadMAF   !$pragma C(OpenMAF,CloseMAF,ReadMAF)

!
!---get MAF and set up for coordinate calculations
!----identify image file
 11	WRITE(6,'(A,$)') 'Enter complete image file name >'
	READ(5,'(Q,A)',END=95) N,FileName
	IF (N.EQ.0) GO TO 95
!----open file, read header record, get photometer ID (1, 2, or 3)
        i = Index (FileName, ' ')
        FileName ( i:i ) = Char (0)
        Call OpenMAF (FileName)
        Call ReadMAF (Header, 404)
        Call MAF_Header ()
        nPhot = ID
!----coordinate calculation setup
	CALL IMAGEIN(FileName)
	CALL SETCRD
!
!---open output files in default directory and MAF
	WRITE(6,*) FileName
	I1 = MAX(INDEX(FileName,']'),INDEX(FileName,':')) + 1
	L = LEN(FileName)
	I2 = I1
	IND = INDEX(FileName(I1+1:L),'.')
	DO WHILE (IND.GT.0)
	    I2 = I2 + IND
	    IND = INDEX(FileName(I2+1:L),'.')
	ENDDO
	I2 = I2 - 1
	WRITE(NFILE,'(A)') FileName(I1:I2)//'.geo'
!	OPEN(UNIT=3,NAME=NFILE,FORM='UNFORMATTED',TYPE='NEW')
	OPEN(UNIT=3,NAME=NFILE,TYPE='NEW')
	WRITE(NFILE,'(A)') FileName(I1:I2)//'.cgm'
!	OPEN(UNIT=4,NAME=NFILE,FORM='UNFORMATTED',TYPE='NEW')
	OPEN(UNIT=4,NAME=NFILE,TYPE='NEW')
        Call OpenMAF (FileName)
        Call ReadMAF (Header, 404)
        Call MAF_Header ()
!
!---write header records
	CALL INITHD
!
!---write two coordinate records for each scan line
        
	DO K=1,LINES
            Call ReadMAF (SCAN, 174)
            Call MAF_ScanLine ()
 	    CALL CLINE
        EndDo
!
!---close files
	CLOSE(UNIT=3,STATUS='KEEP')
	CLOSE(UNIT=4,STATUS='KEEP')
        Call CloseMAF ()
!
	GO TO 11
!
 95	CONTINUE
	END
!
!
!
	SUBROUTINE INITHD
!
!  writes header records for .GEO and .CGM files on units 3 and 4;
!  assumes .MAF is open on unit 2
!
	INCLUDE 'MAFrec.inc'
!
	COMMON /COORDS/KHEAD,KSCAN
!
	BYTE		KHEAD(200),KSCAN(628)
	INTEGER*2	KWORDS,KBLOCK,KBYTES,MAXBYT,MAFCRD,KDIRCT(3),
     &			NUMBER,K,nPhot
	INTEGER*4	KTYPE,KLINES,KMSOA,KALTTD
	REAL*4		SP,ALT
	CHARACTER*4	NAME
!
	EQUIVALENCE	(KHEAD( 1),KWORDS),      (KHEAD(37),KLINES    ),    
     &			(KHEAD( 3),KBLOCK),      (KHEAD(41), KMSOA    ),
     &			(KHEAD( 5),KBYTES),      (KHEAD(125),KALTTD   ),
     &			(KHEAD( 7),MAXBYT),      (KHEAD(193),MAFCRD   ),
     &			(KHEAD( 9), KTYPE),      (KHEAD(195),KDIRCT(1))
!
!
!---get altitude for this filter
        nPhot = ID
	CALL FILTERS(nPhot,FWV,NAME,NUMBER,SP,ALT)
	KALTTD = NINT(ALT)*1000
!
!---initialize header record
	KWORDS = 100
	KBYTES = 200
	MAXBYT = MAXPIX*4 + 28
	DO K=13,28
	    KHEAD(K) = HEADER(K)
	ENDDO
	DO K=29,36
	    KHEAD(K) = HEADER(K+12)
	ENDDO
	KLINES = LINES
	KMSOA = MSECOA
	DO K=45,84
	    KHEAD(K) = HEADER(K+72)
	ENDDO
	DO K=85,112
	    KHEAD(K) = HEADER(K+76)
	ENDDO
	DO K=113,124
	    KHEAD(K) = HEADER(K+80)
	ENDDO
	DO K=1,6
	    KHEAD(184+K) = MAFNAME(K)
	ENDDO
	KHEAD(191) = ' '
	KHEAD(192) = ' '
	MAFCRD = 6
	KDIRCT(1) = IMSYNC
	KDIRCT(2) = IDIRCT(3)
	KDIRCT(3) = IDIRCT(4)
!
!---write header records
	KBLOCK = 10*256 + 1
	KTYPE = 10
!	WRITE(3) KHEAD
	KBLOCK = 11*256 + 1
	KTYPE = 11
!	WRITE(4) KHEAD
!
	RETURN
	END
!
!
!
	SUBROUTINE CLINE
!
	INCLUDE 'MAFrec.inc'
!
	COMMON /IMCOORD/IMXMIN,IMXMAX,IMYMAX,STEP,PIXWD,PIXHT,
     &			SP,ALTF,NSPIN,TSPIN,UTNC1,SOLMSEC1,MDIREC
	COMMON /COORDS/ KHEAD,KSCAN
	COMMON /IMAGE/	IMFILE,FCTDWN,FCTACR,NPHOT,CENTRMLC,PIXOFF
!
	BYTE		KHEAD(200),KSCAN(628)
	INTEGER*2	KWRDS,KBYTS,KPIX,KMLC,KOFFST,KPAIRS(2,150),
     &			MDIREC,ISINK,K,indx
	INTEGER*4	NDUTMS,NDPGEI(3),KALTTD,UTPIX,NSPIN,TSPIN,
     &			UTNC1,SOLMSEC1,i
	REAL*4		XS,YS,P(4),ALT,GLAT,GLONG,GLT,GMLAT,GMLONG,GMLT,
     &			IMXMIN,IMXMAX,IMYMAX,STEP,PIXWD,PIXHT,SP,ALTF
	REAL*8		DSTART,DSTOP
	LOGICAL*1	GOOD
	CHARACTER*128	IMFILE
	INTEGER*2	NPHOT,CENTRMLC,PIXOFF
	REAL*4		FCTDWN,FCTACR
!    
	EQUIVALENCE	(KHEAD(125),KALTTD)
!
	EQUIVALENCE	(KSCAN(1),KWRDS),	(KSCAN( 9),     KOFFST),
     &			(KSCAN(3),KBYTS),	(KSCAN(13),     NDUTMS),
     &			(KSCAN(5), KPIX),	(KSCAN(17),  NDPGEI(1)),
     &			(KSCAN(7), KMLC),	(KSCAN(29),KPAIRS(1,1))
!
!---initialize record length fields and MLC
	KWRDS = (LBYTES-22)*2 + 14
	KBYTS = KWRDS*2
	KPIX = LBYTES - 22
	KMLC = IZEXT(MLC)
!
!---get pixel offset to nadir crossing
	KOFFST = INT((IMYMAX-(NDCORR(1)+NDCORR(2)+NDCORR(3))/8.)*10.) -
     &		ISINK(IMSYNC,UIPRO,DCU)*10
!
!---get s/c position and UT for nadir crossing
        indx = KOFFST/10 + 1
	CALL LOCPX(IZEXT(MLC),indx,XS,YS)
        NDUTMS = UTPIX(XS,YS)
!
!---get s/c GEI position at nadir crossing
	DSTART = (MSECOA-NDUTMS)/1.D3
	DSTOP = -DSTART
	CALL DEORBIT(DSTART,DSTOP,0.D0,P)
	DO K=1,3
	    NDPGEI(K) = JIDNNT( DBLE(P(K))*1.D3 )
	ENDDO
!
!---get geographic coordinates for each pixel
	ALT = KALTTD/1.E3
	DO K=1,KPIX
	    CALL LOCPX(IZEXT(MLC),K,XS,YS)
	    CALL VW2GEO(XS,YS,ALT,GLAT,GLONG,GLT,GOOD)
	    IF (.NOT.GOOD) THEN
		GLAT = -300.0
		GLONG = -300.0
	    ELSE
		IF (GLONG.GT.180.0) GLONG = GLONG - 360.0
	    ENDIF
	    KPAIRS(1,K) = IIFIX(GLAT*100.)
	    KPAIRS(2,K) = IIFIX(GLONG*100.)
	ENDDO
!	WRITE(3) (KSCAN(K),K=1,KBYTS)
        write(3,10) kbyts, kpix, kmlc, ndutms,
     &              (ndpgei(i) / 1000.0, i = 1, 3),
     &              (kpairs (1, i) / 100.0, kpairs (2, i) / 100.0, i = 1, 150)
!
!---get corrected geomagnetic coordinates for each pixel
	DO K=1,KPIX
	    IF (KPAIRS(1,K).EQ.-30000) GO TO 56
	    GLAT = KPAIRS(1,K)/100.
	    GLONG = KPAIRS(2,K)/100.
	    IF (GLONG.LT.0.) GLONG = GLONG + 360.
	    CALL GEO2MAG(YEAR,DAY,MSEC,GLAT,GLONG,GMLAT,GMLONG,GMLT,GOOD)
	    IF (GOOD) THEN
		IF (GMLT.GT.180.) GMLT = GMLT - 360.
	    ELSE
		GMLAT = -300.0
		GMLT = -300.0
	    ENDIF
	    GO TO 57
 56	    GMLAT = 300.0
	    GMLT = -300.0
 57	    KPAIRS(1,K) = IIFIX(GMLAT*100.)
	    KPAIRS(2,K) = IIFIX(GMLT*100.)
	ENDDO
!	WRITE(4) (KSCAN(K),K=1,KBYTS)
        write(4,10) kbyts, kpix, kmlc, ndutms,
     &              (ndpgei(i) / 1000.0, i = 1, 3),
     &              (kpairs (1, i) / 100.0, kpairs (2, i) / 100.0, i = 1, 150)
10      format (3i4, i9, 3f9.1, 150(2f8.2, 2x))
!
	RETURN
	END
