	SUBROUTINE WCOORD(XMIN,YMIN,XMAX,YMAX,IXMIN,IYMIN,IXMAX,IYMAX)
!
!  sets scaling of integer screen coordinates to real view coordinates;
!  screen Y coordinates increase from top to bottom while view Y coordinates
!  increase from bottom to top;  X coordinates in both systems increase
!  from left to right
!
!			name	type	description
!
!  input arguments:	XMIN	REAL*4	window left edge view X-coordinate
!			YMIN	REAL*4	window bottom edge view Y-coordinate
!			XMAX	REAL*4  window right edge view X-coordinate
!			YMAX	REAL*4	window top edge view Y-coordinate
!			IXMIN	INT*2	window left edge screen X-coordinate
!			IYMIN	INT*2	window top edge screen Y-coordinate
!			IXMAX	INT*2	window right edge screen X-coordinate
!			IYMAX	INT*2	window bottom edge screen Y-coordinate
!
!
	COMMON /WSCALE/ XSC,YSC,XOFF,YOFF
!
	REAL*4		XSC,YSC,XOFF,YOFF,XMIN,YMIN,XMAX,YMAX
	INTEGER*2	IXMIN,IYMIN,IXMAX,IYMAX
!
!---determine scale factors and offsets
	XSC = FLOAT(IXMAX-IXMIN)/(XMAX-XMIN)
	YSC = FLOAT(IYMAX-IYMIN)/(YMAX-YMIN)
	XOFF = IXMIN - XMIN*XSC
	YOFF = IYMIN + YMAX*YSC
!
	RETURN
	END
!
!
!
	SUBROUTINE WPLOT(X,Y,ION)
!
!  converts input view coordinates (X,Y) to integer screen positions (IX,IY);
!  if ion = 2, draws a line to (IX,IY), repositioning operating point;
!  if ion = 3, repositions operating point to (IX,IY) without drawing anything
!
!			name	type	description
!
!  input arguments:	X	REAL*4	horizontal view coordinate
!			Y	REAL*4	vertical view coordinate
!			ION	INT*4	=2 for draw to new point,
!					  =1 for move without drawing
!
!	    result: output call to draw or move to screen position (IX,IY)
!
!
	COMMON /WSCALE/ XSC,YSC,XOFF,YOFF
!
	REAL*4		XSC,YSC,X,Y,XOFF,YOFF
	INTEGER	        ION,IX,IY
!
!---rescale input view coordinates to integer screen coordinates
	IX = NINT(X*XSC + XOFF)
	IY = NINT(YOFF - Y*YSC)
!
!--draw or move without drawing depending on ION value
	IF (ION.EQ.2) THEN
	    CALL DRAW(IX,IY)
	ELSE
	    CALL MOVE(IX,IY)
	ENDIF
!
	RETURN
	END
