	SUBROUTINE SETPLT
!
!  opens the gplot.dat file if it exists and reads the previously saved
!  displayed pixel values into the SCREEN buffer, which is an array sized 
!  to resemble a display device
!
	Common /DISPLAY/Screen, CX, CY

        Byte            Screen (0:767, 0:1023)
        Integer         CX, CY

        Byte            Buffer (0:767)
        Integer         I, K
	Logical		EXIST

        External OpenGplot,CloseGplot   !$pragma C(OpenGplot,CloseGplot)
        External ReadGplot,WriteGplot   !$pragma C(ReadGplot,WriteGplot)

!---does display file exist?
	INQUIRE(FILE='gplot.dat',EXIST=EXIST)
!---if so, open and read records into SCREEN columns
	IF (EXIST) THEN
!	    OPEN(UNIT=3,FILE='gplot.dat',FORM='UNFORMATTED')
!     &			RECL=384,TYPE='OLD')
            Call OpenGplot ('gplot.dat')
	    DO K=0,1023
!		READ(3) (SCREEN(I,K),I=0,767)
                Call ReadGplot (Buffer, 768)
                Do i = 0, 767
                    Screen (i, k) = Buffer (i)
                EndDo
	    ENDDO
!	    REWIND 3
!---otherwise, open new file
	ELSE
!	    OPEN(UNIT=3,FILE='gplot.dat',FORM='UNFORMATTED')
!     &			RECL=384,TYPE='NEW')
            Call OpenGplot ('gplot.dat')
	ENDIF
!
	RETURN
	END
!
!
!
	SUBROUTINE DSPLIN(LINEX,LINEY,LINEOUT,TOTAL)
!
!  fills in one vertical line of pixels in an array sized to resemble a
!  display device
!
!			name	type	description
!
!    input arguments:	LINEX	INT*4	horizontal screen position
!					  for top of line
!			LINEY	INT*4	vertical screen position for
!					  top of line
!			LINEOUT	INT*4	array of values to be displayed
!			TOTAL	INT*4	number of elements in LINEOUT
!
	Common /DISPLAY/Screen, CX, CY

        Byte            Screen (0:767, 0:1023)
        Integer         CX, CY

	Integer	        LINEX, LINEY, LINEOUT (768), I, TOTAL
!
	DO I=1,TOTAL
	    SCREEN(LINEY-1+I,LINEX) = LINEOUT(I)
	ENDDO
!
	RETURN
	END
!
!
!
	SUBROUTINE DRAW(IX,IY)
!
!  draws a line of 255s from the last pen position to the given point
!  in an array representing a graphics display and set the current pen
!  position to the given point; the entry point MOVE only sets the current
!  pen position to the given point
!
!			name	type	description
!
!    input arguments:	IX	INT*4   new horizontal screen position
!			IY	INT*4   new vertical screen position
!
!
	Common /DISPLAY/Screen, CX, CY

        Byte            Screen (0:767, 0:1023)
        Integer         CX, CY

	Integer	        IX,IY,K,II,I,J
	Real  		M
!
	IF (IX.EQ.CX) THEN
	    DO K=CY,IY,ISIGN(1,IY-CY)
		SCREEN(MOD(K,768),IX) = 255
	    ENDDO
	ELSE
	    M = FLOAT(IY-CY)/FLOAT(IX-CX)
	    DO K=CX,IX,ISIGN(1,IX-CX)
		II = I
		I = NINT(M*(K-CX)) + CY
		IF (IABS(I-II).GT.1.AND.K.NE.CX) THEN
		    DO J=II,I,ISIGN(1,I-II)
			SCREEN(MOD(J,768),MOD(K,1024)) = 255
		    ENDDO
		ENDIF
		SCREEN(MOD(I,768),MOD(K,1024)) = 255
	    ENDDO
	ENDIF
!
	ENTRY MOVE(IX,IY)
!
	CX = MOD(IX,1024)
	CY = MOD(IY,768)
!
	RETURN
	END
!
!
!
	SUBROUTINE WRAPUP
!
!  writes the current contents of the SCREEN buffer to the binary disk
!  file gplot.dat
!
	Common /DISPLAY/Screen, CX, CY

        Byte            Screen (0:767, 0:1023)
        Integer         CX, CY


        Byte            Buffer (0:767)
        Integer         I, K

        External OpenGplot,CloseGplot   !$pragma C(OpenGplot,CloseGplot)
        External ReadGplot,WriteGplot   !$pragma C(ReadGplot,WriteGplot)

!
!---write each column into a record in 'gplot.dat'
	DO K=0,1023
!	    WRITE(3) (SCREEN(I,K),I=0,767)
                Do i = 0, 767
                    Buffer (i) = Screen (i, k)
                EndDo
            Call WriteGplot (Buffer, 768)
	ENDDO
!	CLOSE(UNIT=3)
        Call CloseGplot ()
!
	RETURN
	END
